<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 10/19/2003 *
 * ===================                          Last change: 11/19/2005 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-bonus.php                                   *
 * -------------------------------------------------------------------- *
 * Short description : Bonus pages for some extra points                *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Bonusseiten fuer ein paar Extrapunkte            *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2011 by Mailer Developer Team                   *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} elseif (!isMember()) {
	redirectToIndexMemberOnlyModule();
}

// Add description as navigation point
addYouAreHereLink('member', __FILE__);

if ((!isExtensionActive('bonus')) && (!isAdmin())) {
	displayMessage('{%pipe,generateExtensionInactiveNotInstalledMessage=bonus%}');
	return;
} // END - if

if (isExtensionInstalledAndNewer('bonus', '0.6.9')) {
	// Add more bonus points here
	// @TODO Rewrite this to a filter
	$USE = '(0';
	if (getConfig('bonus_click_yn') == 'Y') $USE .= ' + `turbo_bonus`';
	if (getConfig('bonus_login_yn') == 'Y') $USE .= ' + `login_bonus`';
	if (getConfig('bonus_order_yn') == 'Y') $USE .= ' + `bonus_order`';
	if (getConfig('bonus_stats_yn') == 'Y') $USE .= ' + `bonus_stats`';
	if (getConfig('bonus_ref_yn')   == 'Y') $USE .= ' + `bonus_ref`';
	$USE .= ')';
} else {
	// Old version ???
	$USE = '`turbo_bonus`';
}

// Init variables
$lastOnline = '%s';
$ONLINE = '';

// Autopurge installed?
if ((isExtensionActive('autopurge')) && ((getApInactiveSince() > 0))) {
	// Use last online timestamp to keep inactive members away from here
	$lastOnline   = ' AND (UNIX_TIMESTAMP() - `last_online`) < {?ap_inactive_since?}';
} // END - if

// Let's check if there are some points left we can 'pay'...
$result = SQL_QUERY_ESC("SELECT
	`userid`, ".$USE." AS `points`, `last_online`
FROM
	`{?_MYSQL_PREFIX?}_user_data`
WHERE
	" . $USE . " > 0 AND
	`status`='CONFIRMED'
	" . $lastOnline . "
ORDER BY
	`points` DESC,
	last_online DESC,
	userid ASC
LIMIT {?bonus_ranks?}",
	array(
		$ONLINE
	), __FILE__, __LINE__);

// Reset temporary variable and check for users
$OUT = '';
if (!SQL_HASZERONUMS($result)) {
	// Load our winners...
	$count = 1;
	while ($content = SQL_FETCHARRAY($result)) {
		// Prepare data for the template
		$content['count']       = $count;
		$content['last_online'] = generateDateTime($content['last_online'], '2');

		// Load row template
		$OUT .= loadTemplate('member_bonus_row', true, $content);

		// Count one up
		$count++;
	} // END - while
} else {
	// No one is interested in our "active rallye" ! :-(
	$OUT = loadTemplate('member_bonus_404', true);
}

// Free memory
SQL_FREERESULT($result);

// Prepare content array
$content['rows'] = $OUT;

// Load final template
loadTemplate('member_bonus', false, $content);

// [EOF]
?>
